RuntimeServices (Velocity 1.4 API)
Keywords: org.apache.velocity.runtime.RuntimeServices interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Interface RuntimeServices

All Superinterfaces:
  RuntimeLogger

All Known Implementing Classes:
  RuntimeInstance

public interface RuntimeServices
extends RuntimeLogger

Interface for internal runtime services that are needed by the various components w/in Velocity. This was taken from the old Runtime singleton, and anything not necessary was removed. Currently implemented by RuntimeInstance.

Version:
  $Id: RuntimeServices.java,v 1.7.4.1 2004/03/03 23:22:55 geirm Exp $
Author:
  Geir Magusson Jr.

Method Summary
`void` | `addProperty(java.lang.String key, java.lang.Object value)` Add a property to the configuration.
`boolean` | `addVelocimacro(java.lang.String name, java.lang.String macro, java.lang.String[] argArray, java.lang.String sourceTemplate)` Adds a new Velocimacro.
`void` | `clearProperty(java.lang.String key)` Clear the values pertaining to a particular property.
`boolean` | `dumpVMNamespace(java.lang.String namespace)` tells the vmFactory to dump the specified namespace.
`java.lang.Object` | `getApplicationAttribute(java.lang.Object key)` Return the specified applcation attribute.
`boolean` | `getBoolean(java.lang.String key, boolean def)` Boolean property accessor method to hide the configuration implementation.
`org.apache.commons.collections.ExtendedProperties` | `getConfiguration()` Return the velocity runtime configuration object.
`ContentResource` | `getContent(java.lang.String name)` Returns a static content resource from the resource manager.
`ContentResource` | `getContent(java.lang.String name, java.lang.String encoding)` Returns a static content resource from the resource manager.
`int` | `getInt(java.lang.String key)` Int property accessor method to hide the configuration implementation.
`int` | `getInt(java.lang.String key, int defaultValue)` Int property accessor method to hide the configuration implementation.
`Introspector` | `getIntrospector()` Returns the configured method introspection/reflection implemenation.
`java.lang.String` | `getLoaderNameForResource(java.lang.String resourceName)` Determines is a template exists, and returns name of the loader that provides it.
`java.lang.Object` | `getProperty(java.lang.String key)` Allows an external caller to get a property.
`java.lang.String` | `getString(java.lang.String key)` String property accessor method to hide the configuration implementation
`java.lang.String` | `getString(java.lang.String key, java.lang.String defaultValue)` String property accessor method with default to hide the configuration implementation.
`Template` | `getTemplate(java.lang.String name)` Returns a `Template` from the resource manager.
`Template` | `getTemplate(java.lang.String name, java.lang.String encoding)` Returns a `Template` from the resource manager
`Uberspect` | `getUberspect()` Returns the configured class introspection/reflection implemenation.
`Directive` | `getVelocimacro(java.lang.String vmName, java.lang.String templateName)` Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`void` | `init()`
`void` | `init(java.util.Properties p)` Initialize the Velocity Runtime with a Properties object.
`void` | `init(java.lang.String configurationFile)` Initialize the Velocity Runtime with the name of ExtendedProperties object.
`boolean` | `isVelocimacro(java.lang.String vmName, java.lang.String templateName)` Checks to see if a VM exists
`SimpleNode` | `parse(java.io.Reader reader, java.lang.String templateName)` Parse the input and return the root of AST node structure.
`SimpleNode` | `parse(java.io.Reader reader, java.lang.String templateName, boolean dumpNamespace)` Parse the input and return the root of the AST node structure.
`void` | `setConfiguration(org.apache.commons.collections.ExtendedProperties configuration)` Allow an external system to set an ExtendedProperties object to use.
`void` | `setProperty(java.lang.String key, java.lang.Object value)` Allows an external system to set a property in the Velocity Runtime.

Methods inherited from interface org.apache.velocity.runtime.RuntimeLogger
`debug, error, info, warn`

Method Detail

### init

    public void init()
              throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### setProperty

    public void setProperty(java.lang.String key,
                            java.lang.Object value)

  Allows an external system to set a property in the Velocity Runtime.

### setConfiguration

    public void setConfiguration(org.apache.commons.collections.ExtendedProperties configuration)

  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.

### addProperty

    public void addProperty(java.lang.String key,
                            java.lang.Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

### clearProperty

    public void clearProperty(java.lang.String key)

  Clear the values pertaining to a particular property.

### getProperty

    public java.lang.Object getProperty(java.lang.String key)

  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

  Parameters:
    `key` - property to return

### init

    public void init(java.util.Properties p)
              throws java.lang.Exception

  Initialize the Velocity Runtime with a Properties object.

  Throws:
    `java.lang.Exception`

### init

    public void init(java.lang.String configurationFile)
              throws java.lang.Exception

  Initialize the Velocity Runtime with the name of ExtendedProperties object.

  Throws:
    `java.lang.Exception`

### parse

    public SimpleNode parse(java.io.Reader reader,
                            java.lang.String templateName)
                     throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Throws:
    `ParseException`

### parse

    public SimpleNode parse(java.io.Reader reader,
                            java.lang.String templateName,
                            boolean dumpNamespace)
                     throws ParseException

  Parse the input and return the root of the AST node structure.

  Parameters:
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template
  Throws:
    `ParseException`

### getTemplate

    public Template getTemplate(java.lang.String name)
                         throws ResourceNotFoundException,
                                ParseErrorException,
                                java.lang.Exception

  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"

  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `java.lang.Exception` - if an error occurs in template initialization

### getTemplate

    public Template getTemplate(java.lang.String name,
                                java.lang.String encoding)
                         throws ResourceNotFoundException,
                                ParseErrorException,
                                java.lang.Exception

  Returns a `Template` from the resource manager

  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `java.lang.Exception` - if an error occurs in template initialization

### getContent

    public ContentResource getContent(java.lang.String name)
                               throws ResourceNotFoundException,
                                      ParseErrorException,
                                      java.lang.Exception

  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException`
    `java.lang.Exception`

### getContent

    public ContentResource getContent(java.lang.String name,
                                      java.lang.String encoding)
                               throws ResourceNotFoundException,
                                      ParseErrorException,
                                      java.lang.Exception

  Returns a static content resource from the resource manager.

  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException`
    `java.lang.Exception`

### getLoaderNameForResource

    public java.lang.String getLoaderNameForResource(java.lang.String resourceName)

  Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it

### getString

    public java.lang.String getString(java.lang.String key,
                                      java.lang.String defaultValue)

  String property accessor method with default to hide the configuration implementation.

  Returns:
    String value of key or default

### getVelocimacro

    public Directive getVelocimacro(java.lang.String vmName,
                                    java.lang.String templateName)

  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

  Returns:
    String VelocimacroProxy

### addVelocimacro

    public boolean addVelocimacro(java.lang.String name,
                                  java.lang.String macro,
                                  java.lang.String[] argArray,
                                  java.lang.String sourceTemplate)

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)

### isVelocimacro

    public boolean isVelocimacro(java.lang.String vmName,
                                 java.lang.String templateName)

  Checks to see if a VM exists

  Returns:
    boolean True if VM by that name exists, false if not

### dumpVMNamespace

    public boolean dumpVMNamespace(java.lang.String namespace)

  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

### getString

    public java.lang.String getString(java.lang.String key)

  String property accessor method to hide the configuration implementation

  Parameters:
    `key` - property key
  Returns:
    value of key or null

### getInt

    public int getInt(java.lang.String key)

  Int property accessor method to hide the configuration implementation.

  Returns:
    int value

### getInt

    public int getInt(java.lang.String key,
                      int defaultValue)

  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
  Returns:
    int value

### getBoolean

    public boolean getBoolean(java.lang.String key,
                              boolean def)

  Boolean property accessor method to hide the configuration implementation.

  Returns:
    boolean value of key or default value

### getConfiguration

    public org.apache.commons.collections.ExtendedProperties getConfiguration()

  Return the velocity runtime configuration object.

  Returns:
    ExtendedProperties configuration object which houses the velocity runtime properties.

### getApplicationAttribute

    public java.lang.Object getApplicationAttribute(java.lang.Object key)

  Return the specified applcation attribute.

  Parameters:
    `key` - The name of the attribute to retrieve.

### getUberspect

    public Uberspect getUberspect()

  Returns the configured class introspection/reflection implemenation.

### getIntrospector

    public Introspector getIntrospector()

  Returns the configured method introspection/reflection implemenation.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 Apache Software Foundation. All Rights Reserved.